package com.tzld.piaoquan.tencentad.controller;

import com.tzld.piaoquan.tencentad.common.base.CommonResponse;
import com.tzld.piaoquan.tencentad.common.enums.AdBaseVideoStatusEnum;
import com.tzld.piaoquan.tencentad.model.vo.AdBaseVideoParam;
import com.tzld.piaoquan.tencentad.model.vo.AdBaseVideoStatusVo;
import com.tzld.piaoquan.tencentad.model.vo.AdBaseVideoVo;
import com.tzld.piaoquan.tencentad.service.AdBaseVideoService;
import com.tzld.piaoquan.tencentad.utils.page.Page;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("/ad/base/video")
public class AdBaseVideoController {

    @Autowired
    private AdBaseVideoService adBaseVideoService;

    @PostMapping("/add")
    public CommonResponse<Void> addAdBaseVideo(@RequestBody List<AdBaseVideoVo> baseVideoList) {
        return adBaseVideoService.addAdBaseVideo(baseVideoList);
    }

    @GetMapping("/get")
    public CommonResponse<Page<AdBaseVideoVo>> getAdBaseVideo(@RequestParam(defaultValue = "1") Integer pageNum,
                                                              @RequestParam(defaultValue = "10") Integer pageSize,
                                                              @RequestParam(required = false) List<Integer> status) {
        return adBaseVideoService.getAdBaseVideo(pageNum, pageSize, status);
    }

    @GetMapping("/status")
    public CommonResponse<List<AdBaseVideoStatusVo>> getAdBaseVideoStatusVo() {
        List<AdBaseVideoStatusVo> res = new ArrayList<>();
//        res.add(new AdBaseVideoStatusVo(AdBaseVideoStatusEnum.FIRST_VERIFY_SUCCESS.getStatus(), AdBaseVideoStatusEnum.FIRST_VERIFY_SUCCESS.getDesc()));
//        res.add(new AdBaseVideoStatusVo(AdBaseVideoStatusEnum.FIRST_VERIFY_FAIL.getStatus(), AdBaseVideoStatusEnum.FIRST_VERIFY_FAIL.getDesc()));
        res.add(new AdBaseVideoStatusVo(AdBaseVideoStatusEnum.SECOND_VERIFY_SUCCESS.getStatus(), AdBaseVideoStatusEnum.SECOND_VERIFY_SUCCESS.getDesc()));
        res.add(new AdBaseVideoStatusVo(AdBaseVideoStatusEnum.SECOND_VERIFY_FAIL.getStatus(), AdBaseVideoStatusEnum.SECOND_VERIFY_FAIL.getDesc()));
        return CommonResponse.success(res);
    }

    @PostMapping("/verify/first")
    public CommonResponse<Void> firstVerifyAdBaseVideo(@RequestBody AdBaseVideoParam adBaseVideoParam) {
        System.out.println(adBaseVideoParam);
        return adBaseVideoService.firstVerifyAdBaseVideo(adBaseVideoParam);
    }

    @PostMapping("/verify/second")
    public CommonResponse<Void> secondVerifyAdBaseVideo(@RequestBody AdBaseVideoParam adBaseVideoParam) {
        return adBaseVideoService.secondVerifyAdBaseVideo(adBaseVideoParam);
    }

}
