package com.tzld.piaoquan.tencentad.utils;

import lombok.extern.slf4j.Slf4j;
import ws.schild.jave.process.ProcessWrapper;
import ws.schild.jave.process.ffmpeg.DefaultFFMPEGLocator;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

@Slf4j
public class FfmpegUtil {

    public static boolean getTargetThumbnail(String url, String targetPath) {
        try {
            try (ProcessWrapper ffmpeg = new DefaultFFMPEGLocator().createExecutor();) {
                ffmpeg.addArgument("-i");
                ffmpeg.addArgument(url);
                ffmpeg.addArgument("-filter:v");
                ffmpeg.addArgument("select='gt(scene,0.1)',showinfo");
                ffmpeg.addArgument("-vsync");
                ffmpeg.addArgument("vfr");
                ffmpeg.addArgument(targetPath);
                ffmpeg.execute();
                try (BufferedReader br = new BufferedReader(new InputStreamReader(ffmpeg.getErrorStream()))) {
                    blockFfmpeg(br);
                }
            }
        } catch (IOException e) {
            System.out.println(e.getMessage());
            log.error("获取缩略图失败 url={}", url);
            return false;
        }
        return true;
    }

    /**
     * 等待命令执行成功，退出
     *
     * @param br
     * @throws IOException
     */
    private static void blockFfmpeg(BufferedReader br) throws IOException {
        String line;
        // 该方法阻塞线程，直至合成成功
        while ((line = br.readLine()) != null) {
            doNothing(line);
        }
    }

    private static void doNothing(String line) {
        // FIXME: 2023/1/31 正式使用时注释掉此行，仅用于观察日志
        System.out.println(line);
    }
}
